package bg.bas.dcl.CorpusTools;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.net.MalformedURLException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.apache.http.HeaderElement;
import org.apache.http.HeaderElementIterator;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.cookie.Cookie;
import org.apache.http.impl.client.AbstractHttpClient;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicHeaderElementIterator;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.util.EntityUtils;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.bootstrap.DOMImplementationRegistry;
import org.w3c.dom.ls.DOMImplementationLS;
import org.w3c.dom.ls.LSSerializer;
import org.xml.sax.SAXException;

import com.gargoylesoftware.htmlunit.FailingHttpStatusCodeException;
import com.gargoylesoftware.htmlunit.WebClient;
import com.gargoylesoftware.htmlunit.html.HtmlForm;
import com.gargoylesoftware.htmlunit.html.HtmlPage;
import com.gargoylesoftware.htmlunit.html.HtmlSubmitInput;
import com.gargoylesoftware.htmlunit.html.HtmlTextInput;

import bg.bas.dcl.mwe.entities.Chunk;
import bg.bas.dcl.mwe.entities.MWECandidate;
import bg.bas.dcl.mwe.entities.WordAlphabetic;
import bg.bas.dcl.mwe.lists.AlphabetIndex;
import bg.bas.dcl.mwe.lists.SyntacticConstructions;

public class AutomaticMWETagger {
	
	SyntacticConstructions s = new SyntacticConstructions ();
	HashMap<String,Integer> LEMMAfreq = new HashMap<String,Integer>();
	HashMap<String,Integer> MWEfreq = new HashMap<String,Integer>();
	
	AssociationEvaluator evaluator = new AssociationEvaluator();
	
	public static String mainPath = "";
	
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		mainPath = args[0];
		
		String path = mainPath + "/xml-verified-marked-plus1/";//args[0];
		String pathLEMMA = mainPath + "/lexicon/LEMMAfreq-ALL";//args[1];
		String pathMWE = mainPath + "/lexicon/MWEfreq-ALL";//args[2];
		
		AutomaticMWETagger autoMWE = new AutomaticMWETagger();

		System.out.println("Reading lemmas...");
		autoMWE.LEMMAfreq = autoMWE.readFreqDictFromFile(pathLEMMA, true);
		System.out.println("Reading MWEs...");
		autoMWE.MWEfreq = autoMWE.readFreqDictFromFile(pathMWE, false);
		

		autoMWE.findMWEs(path);
	
		
	}

	public HashMap<String,Integer> readFreqDictFromFile(String path, boolean setN) {
		
		HashMap<String,Integer> freq = new HashMap<String,Integer>();
		Scanner scan;
		
		try {
			scan = new Scanner(new File(path),"UTF-8");
			
			while (scan.hasNextLine()) {
				String l = scan.nextLine();
				
				if (AlphabetIndex.getIndex(l.charAt(0))==AlphabetIndex.DEFAULT) continue;
								
				String[] words = l.split("\t");

				if (words.length != 2) continue;
				
				int f = Integer.valueOf(words[1]);
				freq.put(words[0], f);
//				System.out.println(words[0]+"\t"+ f);
//				if (setN) N += f;
			}
			
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return freq;
		
	}
	

	  /**
	   * Recursively walk a directory tree and return a List of all
	   * Files found; the List is sorted using File.compareTo().
	   *
	   * @param aStartingDir is a valid directory, which can be read.
	   */
	   static public List<File> getFileListing(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     validateDirectory(aStartingDir);
	     List<File> result = getFileListingNoSort(aStartingDir);
	     Collections.sort(result);
	     return result;
	   }

	   // PRIVATE //
	   static private List<File> getFileListingNoSort(
	     File aStartingDir
	   ) throws FileNotFoundException {
	     List<File> result = new ArrayList<File>();
	     File[] filesAndDirs = aStartingDir.listFiles();
	     List<File> filesDirs = Arrays.asList(filesAndDirs);
	     for(File file : filesDirs) {
	       result.add(file); //always add, even if directory
	       if ( ! file.isFile() ) {
	         //must be a directory
	         //recursive call!
	         List<File> deeperList = getFileListingNoSort(file);
	         result.addAll(deeperList);
	       }
	     }
	     return result;
	   }

	   /**
	   * Directory is valid if it exists, does not represent a file, and can be read.
	   */
	   static private void validateDirectory (
	     File aDirectory
	   ) throws FileNotFoundException {
	     if (aDirectory == null) {
	       throw new IllegalArgumentException("Directory should not be null.");
	     }
	     if (!aDirectory.exists()) {
	       throw new FileNotFoundException("Directory does not exist: " + aDirectory);
	     }
	     if (!aDirectory.isDirectory()) {
	       throw new IllegalArgumentException("Is not a directory: " + aDirectory);
	     }
	     if (!aDirectory.canRead()) {
	       throw new IllegalArgumentException("Directory cannot be read: " + aDirectory);
	     }
	   }

		static void makeParent(String path,String mainPath){
			  String parent = (new File(path)).getParent();
			 
			  if ((new File(parent)).exists()) return;
			  
			  if (!parent.equals(mainPath)) {
				  makeParent(parent, mainPath);
			  } 
			  
			  (new File(parent)).mkdir();
			  
		}

		
	
	public void findMWEs(String path){

		File startingDirectory= new File(path);
	    List<File> files = null;
	    try{
	    	files = getFileListing(startingDirectory);
	    	System.out.println(files.size());

	    int overlap = 0;
	    SyntacticConstructions s = new  SyntacticConstructions();
	    
	    
	    Writer wr = new OutputStreamWriter(new FileOutputStream(mainPath + "/frequencies/ChiSquare_NO_BNK.txt"), "UTF-8");
	    Writer wrLL = new OutputStreamWriter(new FileOutputStream(mainPath + "/frequencies/LogLikelihood_NO_BNK.txt"), "UTF-8");
	    Writer wrMI = new OutputStreamWriter(new FileOutputStream(mainPath + "/frequencies/MutualInformation_NO_BNK.txt"), "UTF-8");
	    Writer wrEMI = new OutputStreamWriter(new FileOutputStream(mainPath + "/frequencies/EnhancedMutualInformation_NO_BNK.txt"), "UTF-8");

	    
fileloop:   for(File file : files ){
		      if (file.isFile()){
		    	  
		    	  
		    	  if (file.getName().startsWith("._")) continue;
		    	  if (file.getName().endsWith("~")) continue;

					if (file.getName().contains("049509")) continue fileloop;

					try {
						

						DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
			    		DocumentBuilder builder = builderFactory.newDocumentBuilder();
			    		Document document = builder.parse(new FileInputStream(file.getAbsolutePath()));
			    		
			    		Element rootElement = document.getDocumentElement();
			    		
				    	DOMImplementationRegistry registry = DOMImplementationRegistry.newInstance();
				    	DOMImplementationLS lsImpl = 
				    	   (DOMImplementationLS)registry.getDOMImplementation("LS");
				    	LSSerializer serializer = lsImpl.createLSSerializer();

				    	NodeList nodes = rootElement.getChildNodes();
					    
					    System.out.println("Processing " + file.getAbsolutePath());
					    
					    
					    int i = 0;
				    	
				    	WordAlphabetic word = new WordAlphabetic();


	newchunk:		    while (i<nodes.getLength()) {

					    	Chunk chunk = new Chunk();
					    	chunk.id = "";
					    	
					    	if (word.pos!=null) {
					    		chunk.add(word);
					    		chunk.id = word.sen;
					    	}
					    	
					    	while (i<nodes.getLength()){
					    		
						    	Node node = nodes.item(i);
						    	
						    	if(node instanceof Element){
						    		
						    		  Element child = (Element) node;
						    		  
						    		  String token = child.getAttribute("w");
						    		  String lemma = child.getAttribute("l");

						    		  String pos = child.getAttribute("pos");
						    		  String sen = child.getAttribute("sen");
						    		  
						    		  String mwe = child.getAttribute("mwe");
						    		  String mwe_type = child.getAttribute("mwe_type");
				    		  							    		  
						    		  word = new WordAlphabetic();
						    		  word.lemmaStrForm = lemma;
						    		  
						    		  if (token.length() == 0 || AlphabetIndex.getIndex(token.charAt(0))==AlphabetIndex.DEFAULT) {
						    			  i++;//System.err.println("BREAK "+token);
						    			  break;
						    		  }
						    		  
						    		  word.sen = sen;
						    		  word.pos = pos;
						    		  word.mwe = mwe;
						    		  word.mwe_type = mwe_type;

						    		  if (!word.sen.equals(chunk.id)) {
						    			  i++;
						    			  break;
						    		  }


						    		  if (word.pos != null) {
						    			  chunk.add(word);
						    		  }
						    		  
						    		  
						    		  
						    	} 
						    	
						    	
						    	i++;
						    	
					    	}
					    	
					    	// process chunk
					    	if (chunk.size() > 1) {
					    		
					    		
					    		String chStr = chunk.getStruct();
//					    		System.out.println(chStr);
					    		
					    		for (String str : s.BigramConstructions){
					    			String chStr1 = chStr;
					    			int cutAt = 0;
					    			
	constr:				    		while (chStr1.contains(str)) {
					    				int index = chStr1.indexOf(str);
					    				int length = str.length();

					    				
					    				MWECandidate c = new MWECandidate();
					    				
					    				int mwectrpart = 0;
					    				String lemma = "";
					    				String[] lemmas = new String[2];
					    				String[] forms = new String[2];

					    				for (int j = 0; j<length; j++) {
					    					WordAlphabetic a = chunk.get(cutAt + index + j);
					    					
					    					if (!a.pos.startsWith("P")) {
					    						// a.mwe = mwectr+":"+(mwectrpart++);
					    						lemma += a.lemmaStrForm + " ";
					    						
					    						if (!a.pos.startsWith("R")) {
					    							if (lemmas[0] == null) lemmas[0] = a.lemmaStrForm;
					    							else lemmas[1] = a.lemmaStrForm;

					    							if (forms[0] == null) forms[0] = a.wordStrForm;
					    							else forms[1] = a.wordStrForm;
					    						}
					    					}
					    					
					    					c.phrase.add(a);
//					    					chunk.set(cutAt+index+j, a);
//					    					System.out.println(chunk.id);
//					    					System.out.print(indexAlphabetical.tokenIndex.get(chunk.get(index + j).word[0]).get(chunk.get(index + j).word[1]) + " ");
					    				}
					    				lemma = lemma.trim();

					    				if (MWEfreq.containsKey(lemma)) {
					    					
					    					ArrayList<String> mweid = new ArrayList<String>();
					    					
						    				for (int j = 0; j<length; j++) {
						    					WordAlphabetic a = chunk.get(cutAt + index + j);
						    					
						    						String[] mweids = a.mwe.split(";");
						    						ArrayList<Integer> indices = new ArrayList<Integer>();

						    						for (String s1 : mweids) {
						    							if (s1.endsWith(j+"")) {
						    								String id = s1.split(":")[0];
						    								
						    								if(j==0) {
						    									mweid.add(id);
						    								} else {
						    									if (mweid.contains(id)) {
						    										// indices to confirm
						    										indices.add(mweid.indexOf(id));
						    									}
						    								}
						    							}
						    						}
						    						
						    						if (j==0) continue;
						    						for (int p=mweid.size()-1; p>-1; p--){
						    							if (!indices.contains(p)) {
						    								mweid.remove(p);
						    							}
						    						}

						    				}
						    				
						    				if (mweid.size()>0){
						    					if (chunk.size() > cutAt + index + length) {
						    						String mwe = chunk.get(cutAt + index + length).mwe;

						    						int l = 0;
						    						while (mweid.size()>0 && l < mweid.size()) {
						    							String s2 = mweid.get(l);
						    							if (mwe.contains(s2)) mweid.remove(l);
						    							else l++;
						    						}
						    					}
						    				}
						    				
						    				String t = "";
						    				if (mweid.size()>0) {
						    					WordAlphabetic a = chunk.get(cutAt + index);
						    					String[] mwe = a.mwe.split(";");
						    					String[] type = a.mwe_type.split(";");
						    					
						    					for (int l =0; l < mwe.length; l++){
						    						if (mwe[l].startsWith(mweid.get(0))) {
						    							t = type[l];
						    							break;
						    						}
						    					}
						    					
						    				}

						    				
						    				double chi = 0.0;
						    				double LogL = 0.0;
						    				double MI = 0.0;
						    				double EMI = 0.0;
						    				
						    				if (LEMMAfreq.containsKey(lemmas[0]) && LEMMAfreq.containsKey(lemmas[1]) && MWEfreq.containsKey(lemma)){
						    					System.out.println(LEMMAfreq.get(lemmas[0])+"\t"+LEMMAfreq.get(lemmas[1])+"\t"+MWEfreq.get(lemma));
						    					chi = evaluator.getChiSquare(LEMMAfreq.get(lemmas[0]),LEMMAfreq.get(lemmas[1]),MWEfreq.get(lemma),false);
						    					LogL = evaluator.getLogLikelihood(LEMMAfreq.get(lemmas[0]),LEMMAfreq.get(lemmas[1]),MWEfreq.get(lemma),false);
						    					MI = evaluator.getMutualInformation(LEMMAfreq.get(lemmas[0]),LEMMAfreq.get(lemmas[1]),MWEfreq.get(lemma),false);
						    					EMI = evaluator.getEnhancedMutualInformation(LEMMAfreq.get(lemmas[0]),LEMMAfreq.get(lemmas[1]),MWEfreq.get(lemma),false);
						    					
						    				}
						    				
						    				// forms - check for capital letters
						    				
						    				
/**						    				
						    				double chiFromBNK = 0.0;
						    				int[] fromBNK = evaluator.getFrequenciesFromBNK(lemmas[0],lemmas[1]);
						    				
						    					System.out.println(fromBNK[0]+"\t"+fromBNK[1]+"\t"+fromBNK[2]);
						    					chiFromBNK = evaluator.getChiSquare(fromBNK[0],fromBNK[1],fromBNK[2],N_BNK);
						    				
*/						    				
						    				
						    				System.out.println(lemma + "\t" + ((mweid.size() > 0)? mweid.get(0):"0") + "\t" + (t.equals("")?"Y":t)+ "\t" + chi 
//						    						+ "\t" 
//						    						+ chiFromBNK
						    						);

						    				wr.write(lemma + "\t" + ((mweid.size() > 0)? mweid.get(0):"0") + "\t" + (t.equals("")?"Y":t)+ "\t" 
						    						+ LEMMAfreq.get(lemmas[0])+"\t"+LEMMAfreq.get(lemmas[1])+"\t"+MWEfreq.get(lemma)+"\t"
						    						+ chi 
//						    						+ "\t" 
//						    						+ fromBNK[0]+"\t"+fromBNK[1]+"\t"+fromBNK[2] + "\t"
//						    						+ chiFromBNK 
						    						+"\n");
						    				wr.flush();
					    				wrLL.write(lemma + "\t" + ((mweid.size() > 0)? mweid.get(0):"0") + "\t" + (t.equals("")?"Y":t)+ "\t" 
					    						+ LEMMAfreq.get(lemmas[0])+"\t"+LEMMAfreq.get(lemmas[1])+"\t"+MWEfreq.get(lemma)+"\t"
					    						+ LogL 
//					    						+ "\t" 
//					    						+ fromBNK[0]+"\t"+fromBNK[1]+"\t"+fromBNK[2] + "\t"
//					    						+ chiFromBNK 
					    						+"\n");
					    				wrLL.flush();
					    				wrMI.write(lemma + "\t" + ((mweid.size() > 0)? mweid.get(0):"0") + "\t" + (t.equals("")?"Y":t)+ "\t" 
					    						+ LEMMAfreq.get(lemmas[0])+"\t"+LEMMAfreq.get(lemmas[1])+"\t"+MWEfreq.get(lemma)+"\t"
					    						+ MI 
//					    						+ "\t" 
//					    						+ fromBNK[0]+"\t"+fromBNK[1]+"\t"+fromBNK[2] + "\t"
//					    						+ chiFromBNK 
					    						+"\n");
					    				wrMI.flush();

					    				wrEMI.write(lemma + "\t" + ((mweid.size() > 0)? mweid.get(0):"0") + "\t" + (t.equals("")?"Y":t)+ "\t" 
					    						+ LEMMAfreq.get(lemmas[0])+"\t"+LEMMAfreq.get(lemmas[1])+"\t"+MWEfreq.get(lemma)+"\t"
					    						+ EMI 
//					    						+ "\t" 
//					    						+ fromBNK[0]+"\t"+fromBNK[1]+"\t"+fromBNK[2] + "\t"
//					    						+ chiFromBNK 
					    						+"\n");
					    				wrEMI.flush();

					    				chStr1 = chStr1.substring(index+1);
					    				cutAt += index+1;
					    				}
					    			}
					    		}
					    		
					    		// add chunk to file after all mwes been set
					    		
					    	}


					    }
					    

					    
					} catch (FileNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (SAXException e) {
						// TODO Auto-generated catch block
				    	  System.out.println(file.length());
						e.printStackTrace();
						System.err.println(file.getAbsolutePath());
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (ParserConfigurationException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (ClassCastException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (ClassNotFoundException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (InstantiationException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					} catch (IllegalAccessException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

				
		      }
		      
		     
		}
	    
	wr.flush();
	wr.close();
	wrLL.flush();
	wrLL.close();
	wrMI.flush();
	wrMI.close();

    } catch(Exception e){
    	e.printStackTrace();
    }
	}
}
