package bg.bas.dcl.CorpusTools;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

		   class Record {
			
			   HashMap<String,String> attributes = new HashMap<String,String>();
			   
			   ArrayList<String> attributesList = new ArrayList<String>();
			   ArrayList<String> attributesListForMetadata = new ArrayList<String>();
			   
			   String dictFile = "";
			   public HashMap<String,String> dict = new HashMap<String,String>();			   
			   
			   // author_info
			   // author
			   // if defined; otherwise take the value of previous column (unknown, many)
			   

			   // text_info
			   // title
			   // if defined; otherwise take the value of of previous column (one, many)
			   
			   // year
			   // source_type
			   // source
			   
			   // translated: true/false
			   // medium: spoken/written
			   
			   // style
			   // genre
			   // domain
			   
			   // notes
	
			   
			   /* constructors */
			   public Record(HashMap<String,String> dict) {
				   this.dict=dict;
				   setupAttributesList();
				   setupAttributesListForMetadata();
			   }

			   public Record(ArrayList<String> attributesToPrint) {
				   setupAttributesList();
				   setupAttributesListForMetadata();
			   }

			   public Record() throws IOException {

	//			   readDictionaryFromFile();
	//				   setupDomainList();
	//			   setupGenreList();
				   setupAttributesList();
				   setupAttributesListForMetadata();
			   }

				  /** Read the contents of the given file. */
				  void readDictionaryFromFile() throws IOException {
					  
				    String NL = System.getProperty("line.separator");
				    Scanner scanner = new Scanner(new File(dictFile), "UTF-8");
				    
				    if (scanner.equals(null)) return;
				    
				    System.out.println("Scanner created");
				    
				    try {
				      while (scanner.hasNextLine()){
				        String rec = scanner.nextLine();
				        rec = rec.trim();
				        if (rec.length() < 2) continue;
				        if (rec.charAt(0) == '#') 
				        	if (rec.substring(1).trim().equalsIgnoreCase("end")) break;
				        	else continue;
				        String[] entry = rec.split("\t");
				        if (entry.length != 2) continue;
				        
				        dict.put(entry[0],entry[1]);
				      }
				      	      
				    }
				    finally{
				     scanner.close(); 
				    }
				  }


			   
			   // different for fiction - to be unified
			   public void setupAttributesList(){
				   attributesList.add("filename");
				   attributesList.add("path");
				   attributesList.add("date_added_to_corpus");
				   attributesList.add("author_info");
				   attributesList.add("author");
				   attributesList.add("translator_info");
				   attributesList.add("translator");
				   attributesList.add("text_info");
				   attributesList.add("title");
				   attributesList.add("year_of_creation");
				   attributesList.add("publishing_date");
				   attributesList.add("source_type");
				   attributesList.add("source");
				   attributesList.add("translated");
				   attributesList.add("medium");
				   attributesList.add("number_of_words");
				   attributesList.add("style");
				   attributesList.add("genre");
				   attributesList.add("genre_info");
				   attributesList.add("domain1");
				   attributesList.add("domain2");
				   attributesList.add("domain_info");
				   attributesList.add("notes");
				   attributesList.add("keywords");
				   attributesList.add("langs");
			   }

			   public void setupAttributesListForMetadata(){
				   attributesListForMetadata.add("filename");
				   attributesListForMetadata.add("author");
				   attributesListForMetadata.add("translator");
				   attributesListForMetadata.add("title");
				   attributesListForMetadata.add("year_of_creation");
				   attributesListForMetadata.add("publishing_date");
				   attributesListForMetadata.add("source_type");
				   attributesListForMetadata.add("source");
				   attributesListForMetadata.add("translated");
				   attributesListForMetadata.add("medium");
				   attributesListForMetadata.add("number_of_words");
				   attributesListForMetadata.add("style");
				   attributesListForMetadata.add("genre");
				   attributesListForMetadata.add("genre_info");
				   attributesListForMetadata.add("domain1");
				   attributesListForMetadata.add("domain2");
				   attributesListForMetadata.add("domain_info");
				   attributesListForMetadata.add("notes");
				   attributesListForMetadata.add("keywords");
			   }


			   public void setAttribute(String name, String value){
				   
				   if (value == null) value = "";
				   
				   value = value.replaceAll("\\n", " ");
				   value = value.replaceAll("\\t", " ");				   
				   
				   if (attributesList.contains(name))
					   attributes.put(name, value);
				   else System.err.println("Invalid attribute "+name + " " +value);
			   }

			   public String getAttribute(String name){
				   
				   return attributes.get(name);
			   }


			   public String transliterate(String s){
				   String result = "";
				   // exceptions not handled
			
				   
				   for (int i=0; i<s.length(); i++){
					   char c = s.charAt(i);
					   
					   switch (c) {
					   case 'а' : result = result.concat("a"); break;
					   case 'б' : result = result.concat("b"); break;
					   case 'в' : result = result.concat("v"); break;
					   case 'г' : result = result.concat("g"); break;
					   case 'д' : result = result.concat("d"); break;
					   case 'е' : result = result.concat("e"); break;
					   case 'ж' : result = result.concat("zh"); break;
					   case 'з' : result = result.concat("z"); break;
					   case 'и' : result = result.concat("i"); break;
					   case 'й' : result = result.concat("y"); break;
					   case 'к' : result = result.concat("k"); break;
					   case 'л' : result = result.concat("l"); break;
					   case 'м' : result = result.concat("m"); break;
					   case 'н' : result = result.concat("n"); break;
					   case 'о' : result = result.concat("o"); break;
					   case 'п' : result = result.concat("p"); break;
					   case 'р' : result = result.concat("r"); break;
					   case 'с' : result = result.concat("s"); break;
					   case 'т' : result = result.concat("t"); break;
					   case 'у' : result = result.concat("u"); break;
					   case 'ф' : result = result.concat("f"); break;
					   case 'х' : result = result.concat("h"); break;
					   case 'ц' : result = result.concat("ts"); break;
					   case 'ч' : result = result.concat("ch"); break;
					   case 'ш' : result = result.concat("sh"); break;
					   case 'щ' : result = result.concat("sht"); break;
					   case 'ъ' : result = result.concat("a"); break;
					   case 'ь' : result = result.concat("y"); break;
					   case 'ю' : result = result.concat("yu"); break;
					   case 'я' : result = result.concat("ya"); break;
					   case 'А' : result = result.concat("A"); break;
					   case 'Б' : result = result.concat("B"); break;
					   case 'В' : result = result.concat("V"); break;
					   case 'Г' : result = result.concat("G"); break;
					   case 'Д' : result = result.concat("D"); break;
					   case 'Е' : result = result.concat("E"); break;
					   case 'Ж' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("ZH"); 
					   		else result = result.concat("Zh");
					   		break;
					   case 'З' : result = result.concat("Z"); break;
					   case 'И' : result = result.concat("I"); break;
					   case 'Й' : result = result.concat("Y"); break;
					   case 'К' : result = result.concat("K"); break;
					   case 'Л' : result = result.concat("L"); break;
					   case 'М' : result = result.concat("M"); break;
					   case 'Н' : result = result.concat("N"); break;
					   case 'О' : result = result.concat("O"); break;
					   case 'П' : result = result.concat("P"); break;
					   case 'Р' : result = result.concat("R"); break;
					   case 'С' : result = result.concat("S"); break;
					   case 'Т' : result = result.concat("T"); break;
					   case 'У' : result = result.concat("U"); break;
					   case 'Ф' : result = result.concat("F"); break;
					   case 'Х' : result = result.concat("H"); break;
					   case 'Ц' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("TS"); 
					   		else result = result.concat("Ts");
					   		break;
					   case 'Ч' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("CH"); 
					   		else result = result.concat("Ch");
					   		break;
					   case 'Ш' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("SH"); 
					   		else result = result.concat("Sh");
					   		break;
					   case 'Щ' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("SHT"); 
					   		else result = result.concat("Sht");
					   		break;
					   case 'Ъ' : result = result.concat("A"); break;
					   case 'Ь' : result = result.concat("Y"); break;
					   case 'Ю' :
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("YU"); 
					   		else result = result.concat("Yu");
					   		break;
					   case 'Я' : 
						   	if ((i < s.length()-1 && s.charAt(i+1) >= 'А' && s.charAt(i+1) <= 'Я') ||
						   			(i > 0 && s.charAt(i-1) >= 'А' && s.charAt(i-1) <= 'Я'))
						   		result = result.concat("YA"); 
					   		else result = result.concat("Ya");
					   		break;
					   default : result = result.concat(String.valueOf(c)); break;
					   }
				   }
				   
				   return result;
			   }


			   public Record readRecord(String line){
				   
				   String atts[] = line.split("\t");
				   
				   if (atts.length != attributesList.size()) {
//					   System.err.println(atts.length + " " + attributesList.size());
//					   return null;
				   }
				   
				   for (int i = 0; i < Math.min(attributesList.size(),atts.length); i++) {
					   setAttribute(attributesList.get(i), atts[i]);
				   }
				   
				   return this;
			   }
			   
			   public String toMetadata (){
				   String result = "<doc";
//				   HashMap<Integer,String> attr = MetadataGenerator.this.usedAttributesList;
//				   TreeSet<Integer> ts = new TreeSet<Integer>();
//	               ts.addAll(attr.keySet());
				   
				   for (String att : attributesListForMetadata){
					   if (attributes.containsKey(att)){
						   if (att.equals("domain1")){
							   result = result + " domain=\"" 
							   						 + getAttributeForMetadata("domain1") + "\"";
							   continue;
						   }

						   result = result + " " + att+ "=\"" + getAttributeForMetadata(att) + "\"";

						   } else {
						   if (att.equals("author") && attributes.containsKey("author_info")){
								   result = result + " " + att + "=\"" 
								   						 + getAttributeForMetadata("author_info") + "\"";
								   continue;
						   }

						   if (att.equals("translator") && attributes.containsKey("translator_info")){
							   result = result + " " + att + "=\"" 
							   						 + getAttributeForMetadata("translator_info") + "\"";
							   continue;
						   }

						   if (att.equals("title") && attributes.containsKey("text_info")){
							   result = result + " " + att + "=\"" 
							   						 + getAttributeForMetadata("text_info") + "\"";
							   continue;
						   }

						   result = result.concat(" " + att+ "=\"\"");
					   }
				   }
				   
				   return result + ">\n";
			   }
			   
			   public String getAttributeForMetadata(String name){
				   
				   String attValue = attributes.get(name);
				   
				   if (name.equalsIgnoreCase("author") || 
						   name.equalsIgnoreCase("title")) return transliterate(attValue);

				   if (name.equalsIgnoreCase("filename") || 
						   name.equalsIgnoreCase("publishing_date") || 
						   name.equalsIgnoreCase("number_of_words")) return attValue;

				   if (dict.containsKey(attValue)) {
					   return dict.get(attValue);
				   } 

				   return transliterate(attValue);
				   
			   }

	
			   
			   public String toString(){
				   String result = "";
				   
				   for (int i=0; i<attributesList.size(); i++){
					   String attr= attributesList.get(i);
					   
					   if (attributes.containsKey(attr))
						   result = result.concat(attributes.get(attr));
					   
					   if (i < attributesList.size()-1) result = result.concat("\t");
				   }
				   
				   return result;
				   
			   }
			   			
			   

			   
			   
		   }
