package bg.bas.dcl.mwe.entities;

import java.util.ArrayList;

import bg.bas.dcl.mwe.lists.IndexLexicon;

public class Word {
	
	public int word;
	public int lemma;
	public String pos;
	public IndexLexicon tokenLexicon;
	public IndexLexicon lemmaLexicon;
	
	public String cl;
	public String sen;
	public String end;
	public String p;

	public String mwe;

	public Word(){
		
	}

	public Word(IndexLexicon tokenLexicon, IndexLexicon lemmaLexicon){
		this.tokenLexicon = tokenLexicon;
		this.lemmaLexicon = lemmaLexicon;

	}

	public Word readWordFromXML(String xml) {
		
		return this;
	}
	
	public String toString(){
		return tokenLexicon.get(word) + "\t" + lemmaLexicon.get(lemma);
	}

	public String toXML(){
		String XML="<word ";
		String w = tokenLexicon.get(word);
		String l = lemmaLexicon.get(lemma);
		if (w.equals("\"")) w = "&quot;";
		if (l.equals("\"")) l = "&quot;";

		if (w.equals("&")) w = "&amp;";
		if (l.equals("&")) l = "&amp;";
		
		if (w.equals("'")) w = "&apos;";
		if (l.equals("'")) l = "&apos;";

		if (w.equals("<")) w = "&lt;";
		if (l.equals("<")) l = "&lt;";

		if (w.equals(">")) w = "&gt;";
		if (l.equals(">")) l = "&gt;";

		XML += "w=\"" + w + "\" ";
		XML += "l=\"" + l + "\" ";
		
		if (cl != null) XML += "cl=\"" + cl + "\" ";
		if (end != null) XML += "e=\"" + end + "\" ";
		if (sen != null) XML += "sen=\"" + sen + "\" ";
		if (p != null) XML += "p=\"" + p + "\" ";
		if (pos != null) XML += "pos=\"" + pos + "\" ";
		if (mwe != null) XML += "mwe=\"" + mwe + "\" ";

		XML += "/>\n";
		return XML;
	}

	public String getWord(){
		return tokenLexicon.get(word);
	}
	
	public String getLemma(){
		return lemmaLexicon.get(lemma);
	}

	public boolean isMWE(){
		return (mwe != null) ? true : false;
	}

	public boolean isEmpty(){
		return tokenLexicon.get(word).equals("====") ? true : false;
	}

}
